package eu.e99.sundermans;

import net.minecraft.block.BlockState;
import net.minecraft.block.Blocks;
import net.minecraft.block.TallFlowerBlock;
import net.minecraft.block.enums.DoubleBlockHalf;
import net.minecraft.entity.EntityType;
import net.minecraft.entity.mob.EndermanEntity;
import net.minecraft.world.World;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;

@Mixin(EndermanEntity.class)
public class EndermanEntityMixin {

    @Inject(method = "<init>", at = @At("RETURN"))
    private void sunderman$init(EntityType<? extends EndermanEntity> entityType, World world, CallbackInfo ci) {
        EndermanEntity entity = (EndermanEntity) (Object) this;

        BlockState carried = Blocks.SUNFLOWER
                .getDefaultState()
                .with(TallFlowerBlock.HALF, DoubleBlockHalf.UPPER);
        entity.setCarriedBlock(carried);
    }

    @Inject(method = "cannotDespawn", at = @At("RETURN"), cancellable = true)
    private void sunderman$cannotDespawn(CallbackInfoReturnable<Boolean> cir) {
        EndermanEntity entity = (EndermanEntity) (Object) this;

        BlockState state = entity.getCarriedBlock();
        if (state == null) {
            return;
        }

        if (!state.isOf(Blocks.SUNFLOWER)) {
            return;
        }

        cir.setReturnValue(false);
    }
}