package eu.e99.sundermans;

import net.minecraft.block.BlockState;
import net.minecraft.block.Blocks;
import net.minecraft.entity.mob.EndermanEntity;
import org.spongepowered.asm.mixin.Final;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Shadow;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;

@Mixin(EndermanEntity.PlaceBlockGoal.class)
public class EndermanPlaceBlockGoalMixin {

    @Shadow
    @Final
    private EndermanEntity enderman;

    @Inject(method = "canStart", at = @At("HEAD"), cancellable = true)
    private void sundermans$canStart(CallbackInfoReturnable<Boolean> cir) {
        EndermanEntity entity = this.enderman;
        BlockState state = entity.getCarriedBlock();
        if (state == null) {
            return;
        }

        if (!state.isOf(Blocks.SUNFLOWER)) {
            return;
        }

        cir.setReturnValue(false);
    }
}
